{ HORIZONT - Variante 'S' - TC 850
Programm zur Erzeugung der Matrizen MTXP1.MTXP2 aus den
Spruchschlsseln DK1, DK2 und Grundschlssel OK sowie von
Vektoren (d1,d2,...,d7,g),(0,d11,d12,...,d17) mit Klartext1,2
verschieden von 0 bis Ts<=65520, identisch 0 ab Ts.
Tmax nur durch Diskettengrge begrenzt         }

program HZVerS01;  { Variante "S" TC 850 mit Pointer }

uses crt,dos,printer;

type
matrix=array[0..7,0..15] of byte;
slmat=array[1..16,1..8] of byte;
vektor=array[1..8] of byte;
allreg=array[1..31] of byte;
RegSatz=array[1..8] of allreg;
Rcnum=array[1..18] of byte; { 18=max Anzahl Rckkopplungen }
RcSatz=array[1..8] of Rcnum;
SlMatrix=array[1..16,1..8] of byte;
string16=string[16];
string10=string[10];
string13=string[13];
string128=string[128];
zeile60=string[60];
menge=set of char;
Bytefeld=array[1..65520] of byte;
Bytefile=file of byte;
Pointer_of_Bytefeld=^Bytefeld;
ITA_Reg=array[1..26] of byte;
ITA_Zei=array[1..26] of char;

var
OK:zeile60; { Grundschlssel }
DK1:zeile60; { Spruchschlssel1 }
DK2:zeile60; { Spruchschlssel2 }
SK:matrix; { Strukturschlssel }
MTXB:slmat; { OK-Matrix }
MTXD1:slmat; { DK1-Matrix }
MTXD2:slmat; { DK2-Matrix }
MtxP1,MtxP2:matrix; { Matrizen P1,P2}
X,D1,D2,C1,C2:vektor; { Registerausgnge x,d1,d2,x+d1,x+d2 }
Gamma1,Gamma2:byte; { Additionseinheiten fur DKI,DK2 }
K1,K2:byte; { Elemente Klartexte 1,2 }
G1,G2:byte; { Elemente der Geheimtexte G1,G2 }
gt:byte;    { gt aus Gleichung 4 }
resbyte:byte; { Byte, das Vektor (d1,d2,...d7,gt) binr darstellt }
resbyted1:byte; { Byte, das Vektor (0,d11,d12,..,d17) binr darstellt }
i,j,m:integer; { Zhler }
Tmax,Ts,t:longint; { Zhler}
RX:RegSatz; { Registerstze }
RD1:RegSatz;
RD2:RegSatz;
zt1,zt2,zst1,zst2:byte; { zt:=Summe(Ci(t-1)) }
Ende,EinOk,AusOk:boolean; { Prfvariable bevor Program startet }
check:boolean; { mit(=false) und ohne(=true) Lngenprfung von Namen }
P1Name:zeile60; { Name des Files AusgP1 }
P2Name:zeile60; { Name des Files AusgP2 }
ResName:zeile60; { Name des Files AusgFile }
Nameskdat:zeile60; { Name des Files Skdat }
SKDat:File of byte; { File der Strukturmatrix }
AusgP1:File of byte; { File der Matrix P1 }
AusgP2:File of byte; { File der Matrix P2 }
AusgFile:File of byte; { File der erzeugten Daten }
Kt1file:file of byte; { File der Klartextdatei 1 vom Typ txt }
Kt2file:file of byte; { --.-- 2 --.-- }
Kt1name:zeile60; { Name Klartextdatei1 }
Kt2name:zeile60; { Name Klartextdatei2 }
Kt1,Kt2:Pointer_of_Bytefeld;
Taste:char;
vek128:string128;
Rueck,Alt:zeile60;
BitVar:integer; { 5- oder 7-bit-Variante }
Feld5Gt1,Feld5Gt2:array[1..5] of byte; { fr Subst V-Bigramm }
ByteGt1,ByteGt2:byte; { aus Feld5Gtx gebildetes Byte }
st_in_gt1,st_in_gt2:boolean; { Merker fur Steuerkombination }
index1,index2:integer;

const
RC:RcSatz=((3,5, 8,10,11,14,16,21,24,26,29,31, 0, 0, 0, 0, 0, 0), { Register 1 }
           (2,7,12,15,17,19,21,22,26,27,28,29, 0, 0, 0, 0, 0, 0), { Register 2 }
           (2,3, 4, 6, 7, 8,10,11,14,17,19,21,24,26,27,28, 0, 0), { Register 3 }
           (1,2, 4, 8, 9,10,11,14,15,16,18,22,25,27, 0, 0, 0, 0), { Register 4 }
           (5,8,12,13,17,18,19,20,22,23,24,25, 0, 0, 0, 0, 0, 0), { Register 5 }
           (1,5, 6, 7, 8, 9,10,11,12,13,14,23, 0, 0, 0, 0, 0, 0), { Register 6 }
           (2,3, 4, 5, 7, 9,10,17,18,19, 0, 0, 0, 0, 0, 0, 0, 0), { Register 7 }
           (2,3, 4, 5, 6, 7, 8,15,17,19,20,22,23,26,28,29,30,31)); { Register 8 }
Skok:boolean=false;
Okok:boolean=false;
Dk1ok:boolean=false;
Dk2ok:boolean=false;
Tok:boolean=false;
Tsok:boolean=false;
Dateibez:menge=['A'..'Z','a'..'z','0'..'9', '.', '_', ' ', ':'];
Bu:menge=['A'..'Z','a'..'z'];
ITA2_Hex:ITA_Reg=($18,$13,$0E,$12,$10,$16,$0b,$05,$0C,$1a,$1e,$09,$07,$06,
                  $03,$0D,$1D,$0A,$14,$01,$1C,$0F,$19,$17,$15,$11);
ITA2_Bu:ITA_Zei=('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
                 'P','Q','R','S','T','U','V','W','X','Y','Z');
ITA2_ZZ:ITA_Zei=('-','?',':','@','3','@','@','@','8','@','(',')','.',',','9',
                 '0','1','4','"','5','7','=','2','/','6','+');
Steuerkomb_hex:array[1..6] of byte=($00,$02,$04,$08,$1B,$1F);
Steuerkomb_zei:array[1..6] of char=('|', '<', ' ', '*', '#', '%');

{--------------------------------------------------------  Prozedur aus Tools }

procedure einzeil(Var st:zeile60;tex:zeile60;m:menge;l,ze,sp:integer);
const s:set of byte=[8,75,77];
var i:integer;
    ta:string[2];
    c:char;

procedure cure; begin
inline($50/$52/$b4/02/$b2/$1b/$cd/$21/$b2/$5b/$cd/$21);
inline($b2/$31/$cd/$21/$b2/$43/$cd/$21/$5a/$58);
end;

procedure culi;
begin
inline($50/$52/$b4/02/$b2/$1b/$cd/$21/$b2/$5b/$cd/$21);
inline($b2/$31/$cd/$21/$b2/$44/$cd/$21/$5a/$58);
end;

begin
  st:='';
  for i:=1 to l do st:=st+' ';
  for i:=1 to length(tex) do st[i]:=tex[i];
  i:=1;gotoxy(ze,sp);write(tex);
  repeat
    gotoxy(ze+i-1,sp);
    c:=readkey;
    case c in m of
    true: ta:=c;
    false: case ord(c) in s of
             true: ta:=chr(27)+c;
             false: case ord(c) of
                      0:begin c:=readkey;
                              if ord(c) in s then ta:=chr(27)+c
                              else ta:='' end
                      else ta:=''
                      end;
              end;
    end;
   if ta<>''then
   begin
     if ta[1]<>chr(27) then begin write(c);st[i]:=c;
                                  if i<l then i:=i+1 else culi
                            end else
     case ord(ta[2]) of
     8: if i>1 then begin st[i]:=' '; i:=i-1; st[i]:=' ';
                          culi;write('  ');culi;culi
                     end;
     75: if i>1 then begin i:=i-1;culi end;
     77: if i<l then begin i:=i+1;cure end;
     end;
     end;
  until c=chr(13);
  i:=l+1;
  repeat
    i:=i-1
  until (i=0) or (st[i]<>' ');
  if i<>0 then st:=copy(st,1,i)
  else st:='';
end;
{--------------------------------------------------------------------
Registerverschiebung fr beliebige Register mit Rckkopplung rck und
dem Ausgang cbit }

procedure regv(var reg:allreg;var cbit:byte;rueck:rcnum);

var
i:integer;
reglaenge:byte;

begin
  cbit:=0;
  for i:=1 to 18 do
      if rueck[i]<>0 then begin
          cbit:=cbit xor reg[rueck[i]];
          reglaenge:=rueck[i];
        end;
  for i:=reglaenge downto 2 do reg[i]:=reg[i-1];
  reg[1]:=cbit;
end;

{------------------------- Registerverschiebung eines Registersatzes }

procedure RegVerSatz(var register:regsatz;rkopp:rcsatz;var abit:vektor);

var
  i:integer;
begin
  for i:=1 to 8 do
    Regv(register[i],abit[i],rkopp[i]);
end;


{--------------------------  Registerverschiebung der drei Registerstze RX,RD1,RD2 }

procedure AllRegVer;

begin
   RegVerSatz(RX,RC,X);
   RegVerSatz(RD1,RC,D1);
   RegVerSatz(RD2,RC,D2);
end;

{--------------------------  Funktion 2 Koch x }

Function Pot2(x:integer):integer;

Var
  i:integer;
  Erg:integer;

begin
  if x=0 then pot2:=1
  else
    begin
      Erg:=1;
      for i:=1 to x do Erg:=Erg*2;
      Pot2:=Erg;
  end;
end;

{------------------ Erzeugung eines Zeilenvektors aus einem Schlsselbuchstaben }

procedure Mzeile(var Zeile:vektor;Bu:char);

Var
  i:integer;
  By:real;
  hiz:vektor;

begin
  by:=ita2_hex[ord(bu)-64];
  for i:=8 downto 1 do
    begin
      if (by/Pot2(i-1)<1) then zeile[9-i]:=0
      else begin
        zeile[9-i]:=1;
        by:=by-Pot2(i-1);
      end;
    end;
  for i:=1 to 5 do
    hiz[i]:=zeile[i+3];
  for i:=6 to 8 do
    hiz[i]:=0;
  for i:=1 to 8 do
  zeile[i]:=zeile[i] xor hiz[i] and 1;
end;

{----------------------- Erzeugung der Matrix B aus dem Grundschlssel }

procedure MatrixB (Var mat:slmat;Grsl:string10);

Var
  i,j:integer;
  bu:char;
  zeile:vektor;

begin
  for i:=1 to 10 do
     begin
       bu:=grsl[i];
       mzeile(zeile,bu);
       for j:=1 to 8 do mat[i,j]:=zeile[j];
     end;
  for i:=2 to 7 do
    begin
      bu:=grsl[i];
      mzeile(zeile,bu);
      for j:= 1 to 8 do mat[9+i,j]:=zeile[j];
    end;
end;

{------------------------  Erzeugung der Matrix D1,D2 aus den Spruchschlsseln }

procedure MatrixD (Var mat:slmat;Spsl:string10);

Var
  i,j:integer;
  bu:char;
  zeile:vektor;

begin
  for i:=1 to 10 do
    begin
      bu:=spsl[i];
      mzeile(zeile,bu);
      for j:=1 to 8 do mat[i,j]:=zeile[j];
    end;
    for i:=11 to 16 do
      begin
        bu:=spsl[i-10];
        mzeile(zeile,bu);
        for j:=1 to 8 do mat[i,j]:=zeile[j];
      end;
end;

{---------------------  Erzeugung der drei Matrizen MTXB,MTXD1,MTXD2 }

procedure GenMatx (var MTXB,MTXD1,MTXD2:slmat;OK:string10;DK1,DK2:string10);

begin
  MatrixB(mtxb,ok);
  MatrixD(mtxd1,dk1);
  MatrixD(mtxd2,dk2);
end;

{---------------------------------  Initialisieren des Registersatzes X }

procedure InitRegSatzX (Var rset:regsatz;mtx:slmat);

var
  i,j:integer;

begin
  for i:=1 to 8 do
    begin
      rset[i,1]:=0;
      for j:=1 to 16 do rset[i,j+1]:=mtx[j,9-i];
      for j:=1 to 14 do rset[i,j+17]:=mtx[j,9-i];
    end;
end;

{----------------------------------------- Initialisierung Registersatz D }

procedure InitRegSatzD (Var rset:regsatz;mtx:slmat);

Var
  i,j:integer;

begin
  for i:=1 to 8 do
    begin
      rset[i,1]:=1;
      for j:=1 to 10 do rset[i,j+1]:=mtx[j,9-i];
      for j:=1 to 10 do rset[i,j+11]:=mtx[j,9-i];
      for j:=1 to 10 do rset[i,j+21]:=mtx[j,9-i];
    end;
end;

{---------------------------------  lnitialisieren aller drei Registerstze }

procedure GenReg;

Var
  i:integer;

begin
  InitRegSatzX(RX,MTXB);
  InitRegSatzD(RD1,MTXD1);
  InitRegSatzD(RD2,MTXD2);
end;

{-----------------------------------------------  Generieren einer Matrix P }

procedure GenMtxP (Var SPMat:matrix;SKMat:matrix;OKMat,DkMat:slmat);

Var
  i,j,Anz1:integer;
  Ptest:boolean;

begin
  repeat
    Anz1:=0;
    for i:=0 to 7 do
      for j:=0 to 15 do
        begin
          SPMat[i,j]:=((ord(SkMat[i,j])-48) xor DKMat[j+1,8-i] xor OKMat[j+1,8-i]) and 1;
          Anz1:=Anz1+SPMat[i,j];
      end;
    if ((Anz1<33) or (Anz1>95)) then ptest:=false
                                else ptest:=true;  { keine nderung notwendig }
    if ptest=false then for i:=0 to 7 do
                          for j:=0 to 14 do Skmat[i,j]:=Skmat[i,j+1];
  until ptest=true;
  if (Anz1/2)=int(anz1/2) then spmat[0,0]:=spmat[0,0] xor 1;
end;

{---------------------------------------------------  Erzeugung x+d1,x+d2 }

procedure Addxd;

Var i:integer;

begin
  for i:=1 to 8 do
    begin
      c1[i]:=x[i] xor d1[i];
      c2[i]:=x[i] xor d2[i];
    end;
end;

{----------------------------------  Auswahl eines Matrixelementes bezglich eines Vektors (y1..y8) }

procedure ElmPij (Var el:byte; mtxp:matrix; vek:vektor);

var
  i,zeile,spalte:integer;

begin
  zeile:=0;spalte:=0;
  for i:=1 to 4 do spalte:=spalte+vek[i]*Pot2(i-1);
  for i:=5 to 7 do zeile:=zeile+vek[i]*Pot2(i-5);
  el:=mtxp[zeile,spalte]; { write(lst,zeile,' ',spalte:2,' ',e1,' '); }
end;

{-----------------------------------------------  Erzeuaung eines Gamma pro Takt }

procedure Gamma (Var Gamma:byte; mtxp:matrix; vek:vektor; zt:byte);

Var Pij:byte;

begin
  ElmPij(Pij,mtxp,vek);
  Gamma:=Pij xor vek[8];
  Gamma:=Gamma xor zt;
end;

{---------------------------------------------------  Erzeugung zt:=Summe(ci(t-1)) }

procedure Elmzt (Var zt:byte;vek:vektor);

Var i:integer;

begin
  zt:=0;
  for i:=1 to 8 do zt:=zt xor vek[i];
end;

{--------------------------------------------- Konvertierung eines hex-Byte in 8 0,1-Byte }

procedure Konv(var Feld:vektor;b:byte);

Var
 i,y:integer;

begin
  for i:=1 to 8 do
    begin
      y:=Pot2(8-i);
      if ((b-y)>=0) then begin
                           b:=b-y;
                           Feld[i]:=1;
                         end
      else Feld[i]:=0;
    end;
end;

{---------------------------------------- Substitution Bu,ZZ -- ITA-Kombination als hex-Byte }

procedure Impuls(Var kombi:byte;Var flag:boolean);

Var i:integer;

begin
  for i:=1 to 26 do
    if ((kombi=byte(ITA2_Bu[i])) or (kombi=byte(ITA2_ZZ[i]))) then kombi:=ITA2_hex[i];
    for i:=1 to 6 do
      if kombi=byte(steuerkomb_zei[i]) then kombi:=steuerkomb_hex[i];
    if kombi=$1F then flag:=true;
    if kombi=$1B then flag:=false;
end;

{---------------------------  Umwandlung von 2 Klartextfiles in 2 Bytefelder der Lnge Ts<=65520 }

procedure GenK1K2;

Var
  Bt:byte;
  Btfeld:vektor;
  i:longint;
  j:integer;
  Flag1,Flag2:boolean; { true=Buchstaben }

begin
  i:=0;
  Flag1:=true;Flag2:=true;
  repeat
    read(Kt1file,Bt);
    impuls(bt,flag1);
    Konv(Btfeld,Bt);
    for j:=1 to Bitvar do Kt1^[i+j]:=Btfeld[8-BitVar+j];
    read(Kt2file,Bt);
    impuls(bt,flag2);
    Konv(Btfeld,Bt);
    for j:=1 to BitVar do Kt2^[i+j]:=Btfeld[8-BitVar+j];
    i:=i+BitVar;
  until ((i>=Ts) or (i+Bitvar>65520) or eof(kt1file) or eof(kt2file));
  close(kt1file);close(kt2file);
end;


{--------------------------------------- Fehlerausschrift fur Dateifehler }

procedure Dateifehler(Name:string10;x,y:integer);

begin
  gotoxy(x,y);
  write('Datei "',name,'" existiert nicht!    ');
  delay(5000);
end;

{------------------------------------------ Erzeugung gt (Gleichung 4) }

procedure TxtAdd (Var gt:byte;gam1,gam2,k1,k2:byte;vek1,vek2:vektor; zt1,zt2:byte);

Var i:integer;

begin
  gt:=gam1 xor k1 xor gam2 xor k2 xor zt1 xor zt2 xor vek1[8] xor vek2[8];
  gt:=gt and 1;
end;

{---------------------------------  Erzeugung des Ergebnisbytes RESBYT=(d7,...,d1,gt) }

procedure Result (Var Resbyt:byte;D1,D2:vektor;gt:byte);

Var
  i:integer;
  hv:vektor;

begin
  resbyt:=0;
  for i:=1 to 7 do hv[i]:=D1[8-i] xor D2[8-i];
  hv[8]:=gt;
  for i:=8 downto 1 do Resbyt:=Resbyt+hv[i]*Pot2(8-i);
end;

{------------------------ Erzeugung des Ergebnisbytes RESBYTED1=(0,d11,d12,...,d17) }

procedure ResD1(Var Byte:byte);

Var
  i:integer;
  hv:vektor;

begin
  byte:=0;
  hv[1]:=0;
  for i:=1 to 7 do hv[i+1]:=D1[8-i];
  for i:=8 downto 1 do byte:=byte+hv[i]*Pot2(8-i);
end;

{------------------------------------------- Einlesen Strukturschlsselmatrix }

procedure SKein (var Mtx:matrix);

Var
  i,j:integer;
  Filein:file of byte;
  Filename:string[13];

begin
  gotoxy(20,15);
  writeln('Filename SK-Datei:');
  read(filename);
  assign(filein,filename);
  reset(filein);
  for i:=0 to 7 do
    for j:=0 to 15 do
      read(filein,mtx[i,j]);
  close(filein);
end;

{----------------------------------- Ausgabe einer Matrix P auf File }
procedure Mtxausg(Mtx:matrix; Filename:string10);

Var
  i,j:integer;
  Fileaus:file of byte;

begin
  assign(fileaus,filename);
  rewrite(fileaus);
  for i:=0 to 7 do
    for j:=0 to 15 do
      write(fileaus,mtx[i,j]);
  close(fileaus);
end;

{----------------------------------------   Hauptmen }

procedure Menue;

begin
  clrscr;
  writeln('***************************************************************************');
  gotoxy(7,3);
  writeln('HORIZONT - statistische Methode: Erzeugung der Testdaten');
  gotoxy(18,4);
  writeln('Programm "HzVerS01"-Var "S" TC 850, KT="0" ab 0<=Ts<=65520');
  gotoxy(1,6);
  writeln('**************************************************************************');
  gotoxy(20,8);
  writeln('F1: Eingaben');
  gotoxy(20,9);
  writeln('F2: Ausgaben');
  gotoxy(20,10);
  writeln('F3: Programmstart');
  gotoxy(20,11);
  write('F10: Programmende');
end;

{------------------------------------------------------------------- bertragung SK }

procedure EingSK(var SK:matrix);

var
  i,j:integer;

begin
  for i:=0 to 7 do
    for j:=0 to 15 do
    sk[i,j]:=ord(vek128[i*16+j+1]);
end;

{----------------------------------------------------- Ummandlung Klein- in Grobuchstaben }

procedure grossbu(var Kette:zeile60);

Var
  i:integer;

begin
  for i:=1 to length(Kette) do
    Kette[i]:=upcase(Kette[i]);
end;

{------------------------------------------------------ Einagben SK,OK,DKI,DK2,T }

procedure Eingaben;

Var
  Taste:char;
  x,y,i,j,code:integer;
  M01:menge;
  Mziff:menge;
  vekzeil:zeile60;
  ch:char;

const
  bvz:menge=['5','7'];

begin
  M01:=['0','1'];Mziff:=['0'..'9'];
  inline($b1/05/$b5/00/$b4/1/$cd/$10);
  check:=false;
  window(5,7,60,25);
  textbackground(lightgray);
  textcolor(black);
  clrscr;
  write('Eingaben: ');
  gotoxy(1,wherey+2);x:=wherex;y:=wherey;
  repeat
    gotoxy(x,y);
    write('Grundschlssel: ');
    einzeil(Ok,Ok,Bu,10,wherex,wherey);
  until length(Ok)=10;
  Grossbu(Ok);
  Okok:=true;
  gotoxy(1,wherey+1);x:=wherex;y:=wherey;
  repeat
    gotoxy(x,y);
    write('Spruchschlssel 1: ');
    einzeil(Dk1,Dk1,Bu,10,wherex,wherey);Dk1ok:=true;
  until length(Dk1)=10;
  Grossbu(Dk1);
  gotoxy(1,wherey+1);x:=wherex;y:=wherey;
  repeat
    gotoxy(x,y);
    write('Spruchschlssel 2: ');
    einzeil(Dk2,Dk2,Bu,10,wherex,wherey);Dk2ok:=true;
  until length(Dk2)=10;
  Grossbu(Dk2);
  gotoxy(1,wherey+1);
  write('Strukturschlssel: ');
  write('Dateiname: ');
  einzeil(Nameskdat,Nameskdat,Dateibez,16,wherex,wherey);
  {$I-} assign(Skdat,Nameskdat);
        reset(Skdat); {$I+}
  code:=ioresult;skok:=false;
  if code=0 then begin
    for i:=0 to 7 do
      for j:=0 to 15 do
        read(skdat,Sk[i,j]);
        close(SKDat);
        Skok:=true;
     end;
  gotoxy(20,wherey+1);
  write('Strukturmatrix: ');
  window(40,13,55,20);
  textcolor(lightgray);
  textbackground(black);
  clrscr;
  window(1,1,80,25);
  vek128:='';
  for i:=0 to 7 do
    for j:=0 to 15 do
    if skok then vek128:=vek128+chr(sk[i,j])
            else vek128:=vek128+' ';
  gotoxy(40,13);x:=wherex;y:=wherey-1;
  for i:=1 to 8 do
    begin
      y:=y+1;
      vekzeil:=copy(vek128,((i-1)*16)+1,16);
      einzeil(vekzeil,vekzeil,M01,16,x,y);
      delete(vek128,((i-1)*16)+1,16);
      insert(vekzeil,vek128,((i-1)*16)+1);
    end;
  EingSk(Sk);
  Skok:=true;
  assign(Skdat,Nameskdat);
  rewrite(Skdat);
  for i:=0 to 7 do
    for j:=0 to 15 do
      write(Skdat,sk[i,j]);
  close(skdat);
  textcolor(black);textbackground(lightgray);
  inline($b1/00/$b5/15/$b4/1/$cd/$10);
  gotoxy(5,wherey+1);
  write('Anzahl Tmax : ');
  x:=wherex;y:=wherey;
  repeat
    str(Tmax,vekzeil);
    einzeil(vekzeil,vekzeil,Mziff,6,x,y);
    val(vekzeil,Tmax,code);
    if Tmax>0 then Tok:=true;
  until Tok;
  gotoxy(5,wherey+1);
  write('Anzahl Ts : ');x:=wherex;y:=wherey;
  repeat str(Ts,vekzeil);
    einzeil(vekzeil,vekzeil,Mziff,6,x,y);
    val(vekzeil,Ts,code);
    Tsok:=true;
  until Tsok;
  gotoxy(5,wherey+1);x:=wherex;y:=wherey;
  if ts<>0 then begin
    repeat
      begin
        gotoxy(x,y);
        write('Dateiname der Klartextdatei1: ');
        einzeil(Kt1name,Kt1name,Dateibez,16,wherex,wherey);
        {$I-} assign(Kt1file,Kt1name);
              reset(Kt1file); {$I+}
        code:=ioresult;
        if code<>0 then begin Dateifehler(Kt1name,x,y);Kt1name:=' ';end;
      end;
    until code=0;
  gotoxy(5,wherey+1);x:=wherex;y:=wherey;
  repeat
    begin
      gotoxy(x,y);
      write('Dateiname der Klartextdatei2: ');
      einzeil(Kt2name,Kt2name,Dateibez,16,wherex,wherey);
      {$I-} assign(Kt2file,Kt2name);
            reset(Kt2file); {I+}
      code:=ioresult;
      if code<>0 then begin Dateifehler(Kt2name,x,y);Kt2name:=' ';end;
    end;
  until code=0;
  end;                     { von ts<>0 }
  Bitvar:=5;
  window(1,1,80,25);
  textcolor(lightgray);textbackground(black);
  if (skok and okok and dk1ok and dk2ok and tok and tsok) then einok:=true;
end;

{------------------------------------------------------ Name des Ausgabefiles }

procedure AusgNamen(Var P1name:zeile60;
                    Var P2name:zeile60;
                    Var Resname:zeile60);

begin
  inline($b1/05/$b5/00/$b4/1/$cd/$10);
  check:=true;
  window(20,7,75,12);
  textbackground(lightgray);
  textcolor(black);
  clrscr;
  gotoxy(1,wherey+1);
  write('Dateiname fr Matrix P1: ');
  einzeil(P1Name,P1Name,Dateibez,16,wherex,wherey);
  gotoxy(1,wherey+1);
  write('Dateiname fr Matrix P2: ');
  einzeil(P2Name,P2Name,Dateibez,16,wherex,wherey);
  gotoxy(1,wherey+1);
  write('Dateiname fr Daten: ');
  einzeil(ResName,ResName,Dateibez,16,wherex,wherey);
  window(1,1,80,25);
  textbackground(black);
  textcolor(lightgray);
  clrscr;
  Ausok:=true;
  inline($b1/00/$b5/15/$b4/1/$cd/$10);
end;

{------------------------------------------------------------ Protokollkopf }

procedure protokoll;

var
  i,j:integer;
  jahr,monat,tag,stunde,min,dayofw,sec,sec100:word;
  stelle:integer;
  no:string[2];
  lmonat,lmin:string[1];

const
  doppelpkt:char=':';

begin
  writeln(lst);
  writeln(lst,'*************************************************************');
  writeln(lst);
  writeln(lst,'HORIZONT - Variante "S", Vers. 1.0');
  Writeln(lst);
  getdate(jahr,monat,tag,dayofw);gettime(stunde,min,sec,sec100);
  if monat<10 then lmonat:='0' else lmonat:='';
  if min<10 then lmin:='0' else lmin:='';
  writeln(lst,'                        Datum: ',tag,'.',lmonat,monat,'.',jahr);
  writeln(lst,'                        Zeit : ',stunde,'.',lmin,min,' Uhr');
  writeln(lst);
  writeln(lst,'=========================PROTOKOLL==========================');
  writeln(lst);
  writeln(lst,' Grundschlssel  :',ok);
  writeln(lst,' Spruchschlssel 1:',Dk1);
  writeln(lst,' Spruchschlssel 2:',Dk2);
  writeln(lst,' Strukturschlsseldatei : ',nameskdat);
  write(lst,' Strukturschlssel : ');
  for i:=0 to 7 do begin
                     for j:=0 to 15 do write(lst,chr(sk[i,j]));
                     writeln(lst);write(lst,'                  ');
                   end;
  writeln(lst);
  writeln(lst,' Tmax: ',tmax);
  writeln(lst,' Ts:   ',ts);
  if ts<>0 then begin
                  writeln(lst,' Datei Klartext 1: ',kt1name);
                  writeln(lst,' Datei Klartext 2: ',kt2name);
                end
     else writeln(lst,' ### Klartexte identisch "0" ###');
  writeln(lst,' Ausgabedatei: ',resname);
  writeln(lst,' Matrixdatei P1: ',p1name);
  writeln(lst,' Matrixdatei P2: ',p2name);
  writeln(lst);writeln(lst);
end;

{------------------------------------------------------ Arbeitsprogramm }

procedure ProgStart;

Var
  i,j:integer;
  kein_leerlauf:boolean;

begin
  if Einok and Ausok then
  begin
    if ts<>0 then GenK1K2;
    t:=0;
    assign(AusgFile,ResName);
    rewrite(AusgFile);
    window(20,12,60,17);
    textbackground(lightgray);
    textcolor(black);
    clrscr;
    gotoxy(10,2);
    write('Programm luft !!!');
    GenMatx(MtxB,MtxD1,MtxD2,Ok,Dk1,Dk2);
    GenReg;
    GenMtxp(MtxP1,Sk,MtxB,MtxD1);
    GenMtxp(MtxP2,Sk,MtxB,MtxD2);
    gotoxy(15,5);write('t= ',t);
    zt1:=0;zt2:=0;zst1:=0;zst2:=0;
    kein_leerlauf:=true;
    repeat                                                    { Vorlauf }
      begin
        t:=t+1;
        AllRegVer;
        Addxd;
        Elmzt(Zt1,D1);
        Elmzt(Zt2,D2);
        Elmzt(Zst1,C1);
        Elmzt(Zst2,C2);
      end;
    until t=150;
    protokoll;
    t:=0;m:=0;index1:=0;index2:=0;
    st_in_gt1:=false;st_in_gt2:=false;
{   writeln(lst,'P1(i,j) P2(i,j) cl(8) z1 ga1 k1 g1 c2(8) z2 ga2 k2 g2 d1(8) d2(8) zd1 zd2 G');
    writeln(lst,'---------------------------------------------------------------------------');
    writeln(lst);  }
    repeat
      begin
        t:=t+1;m:=m+1;if m=6 then begin m:=1; {writeln(lst)};end;
        index1:=index1+1;index2:=index2+1;
        gotoxy(15,5);write('t= ',t);
        if t>=Ts then begin K1:=0;K2:=0 end
        else begin
          if st_in_gt1 then begin
                              index1:=index1-1;
                              k1:=0;
                            end
                            else k1:=kt1^[index1];
          if st_in_gt2 then begin
                              index2:=index2-1;
                              k2:=0;
                            end
                            else k2:=kt2^[index2];
        end;
        AllRegVer;
        Addxd;
        Gamma(G1,MtxP1,C1,zst1);
        Gamma(G2,MtxP2,C2,zst2);
        feld5gt1[m]:=(k1 xor g1) and 1; feld5gt2[m]:=(k2 xor g2) and 1;
        if st_in_gt1 then g1:=0;
        if st_in_gt2 then g2:=0;
        TxtAdd(GT,G1,G2,K1,K2,D1,D2,Zt1,Zt2);
{ writel(lst,c1[8],'   ',zstl,'  ',g1,'  ',k1,'  ',g1 xor k1,'  ',
             c2[8],'   ',zst2,'  ',g2,'  ',k2,'  ',g2 xor k2,'  ',
             d1[8],'   ',d2[8],'  ',zt1,'  ',zt2,'  ',gt);}
        Elmzt(Zt1,D1);
        Elmzt(Zt2,D2);
        Elmzt(Zst1,C1);
        Elmzt(Zst2,C2);
        Result(Resbyte,D1,D2,Gt);
        ResD1(ResbyteD1);
        if (st_in_gt1 or st_in_gt2) then begin
                                           resbyted1:=resbyted1 or 128;
                                         end;
    write(AusgFile,Resbyte);
    write(AusgFile,ResbyteD1);
    if m=5 then begin
                  if st_in_gt1 then st_in_gt1:=false
                  else begin
                         bytegt1:=0;
                         for i:=5 downto 1 do
                           bytegt1:=bytegt1+feld5gt1[i]*Pot2(5-i);
                         for i:=1 to 6 do if bytegt1=steuerkomb_hex[i]
                           then st_in_gt1:=true;
                       end;
                  if st_in_gt2 then st_in_gt2:=false
                    else begin
                           bytegt2:=0;
                           for i:=5 downto 1 do
                             bytegt2:=bytegt2+feld5gt2[i]*Pot2(5-i);
                           for i:=1 to 6 do if bytegt2=steuerkomb_hex[i]
                             then st_in_gt2:=true;
                         end;
                end;
      end;
    until t=Tmax;
    assign(AusgP1,P1Name);
    assign(AusgP2,P2Name);
    rewrite(AusgP1);
    rewrite(AusgP2);
    for i:=0 to 7 do
      for j:=0 to 15 do
        begin
          write(AusgP1,MtxP1[i,j]);
          write(AusgP2,MtxP2[i,j]);
        end;
    end
    else
      begin
        gotoxy(5,2);
        write('Eingabedaten unvollstndig !!!');
      end;
  textcolor(lightgray);
  textbackground(black);
  window(1,1,80,25);
end;


{****************************************************************************
                             HAUPTPROGRAMM
*****************************************************************************}

begin
  new(kt1);new(kt2);
  inline($b1/00/$b5/15/$b4/1/$cd/$10);
  Ende:=false;
  Ausok:=false;
  Einok:=false;
  P1name:=' ';P2name:=' ';Resname:=' ';Nameskdat:=' ';Ok:=' '; Dk1:=' ';
  Dk2:=' ';Tmax:=0;Ts:=0;Kt1name:=' ';Kt2name:=' ';BitVar:=5;
  repeat
    Menue;
      repeat
        Taste:=readkey;
      until taste=#0;
      Taste:=readkey;
      case Taste of
        #59: Eingaben;
        #60: AusgNamen(P1Name,P2Name,ResName);
        #61: ProgStart;
        #68: ende:=true;
      end;
    until ende;
  textcolor(black);textbackground(lightgray);
  gotoxy(20,15);
  write('P r o g r a m m e n d e ! ! !');
  textcolor(lightgray);textbackground(black);
  dispose(kt1);dispose(kt2);
end.