{ SIMULATION - Variante "S" - TC 850
               Programm zur Chiff/Dechiffrierung von Texten der Kennung 'HHHHH'
               Dateinamen werden Ifo_Satz (record-Typ) entnommen:
               - Datei_Kt: Klartext
               - Datei_Gt: Geheimtext
               - Datei_Sl: Struktur- und Grundschlssel
               Spruchschlssel wird dem Text nach Kennung entnommen und mu
               in der Form 'AAABB BCCCD DDEEE FFFGG GHHHI IIJJJ' stehen, wobei
               Steuerzeichen ignoriert werden
               Das jeweils chiff/dechiffrierte Element wird mit write(...)
               angezeigt

Die Software wurde in einigen Punkten optimiert, 27.01.2022                  }
{=========================   Rahmenprogramm =================================}

program simrahmen;

uses crt, dos, windows;

Type
  verfahren = string[22];
  Dtname = string[60];
  ifo_typ = record Verf_bez:verfahren;
                   datei_kt:dtname;
                   datei_gt:dtname;
                   datei_sl:dtname;
            end;

Var
  taste:char;
  betrart:string;
  ifo_satz:ifo_typ;

procedure stoi;
begin taste := readkey; end;
{====================================================================}

procedure SimvarS(art:char; ifo_satz:ifo_typ); { Variante "S" TC 850 }

type
  matrix = array[0..7, 0..15] of byte;
  slmat = array[1..16, 1..8] of byte;
  vektor = array[1..8] of byte;
  allreg = array[1..31] of byte;
  RegSatz = array[1..8] of allreg;
  Rcnum = array[1..18] of byte; { 18=max Anzahl Rckkopplungen }
  RcSatz = array[1..8] of Rcnum;
  SlMatrix = array[1..16, 1..8] of byte;
  string16 = string[16];
  string10 = string[10];
  string13 = string[13];
  string128 = string[128];
  zeile60 = string[60];
  menge = set of char;
  Bytefile = file of byte;
  ITA_Reg = array[1..26] of byte;
  ITA_Zei = array[1..26] of char;
  regtyp = array[1..31] of byte;

var
  OK:zeile60;                    { Grundschlssel }
  DK:zeile60;                    { Spruchschlssel }
  SK:matrix;                     { Strukturschlssel }
  MTXB:slmat;                    { OK-Matrix }
  MTXD:slmat;                    { DK-Matrix }
  MtxP:matrix;                   { Matrix P }
  C:vektor;                      { Registerausgange }
  Gam:byte;                      { Additionseinheit }
  K:byte;                        { Element Klartext }
  G:byte;                        { Element Geheimtext }
  i,j,m,gr:integer;              { Zhler }
  t,tmax,poszei,poskenn:longint; { Zahler, Positionen in Datei }
  Reg:RegSatz;                   { Registersatz }
  zt:byte;                       { zt:=Summe(Ci(t-1)) }
  Ende,EinOk,AusOk:boolean;      { Prfvariable bevor Programm startet }
  check:boolean;                 { mit(=false) and ohne(=true) Laengenprfung von Namen }
  Nameskdat:zeile60;             { Name des Files Skdat }
  SKDat:File of byte;            { File der Strukturmatrix }
  Quelldatei,Zieldatei,Sldatei:file of byte; { Files der Textdateien }
  Taste:char;
  vek128:string128;
  Rueck, Alt:zeile60;
  BitVar:integer;                { 5- oder 7-bit-Variante }
  Feld5Gt:array[1..5] of byte;   { fr Subst Y-Bigramm }
  ByteGt:byte;                   { aus FeldSGt gebildetes Byte }
  st_in_gt, textende:boolean;    { Merker fur Steuerkombination,textende }
  index:integer;
  codeq,codez,codes:integer;     { ioresult-codes }
  ghel, ghelnf, klareinheit, addel:byte; { Textelemente,Nachfolger }
  leertakte, buflag, wrzv:boolean;
  regist:regtyp;

const
  maske:regtyp=($14,$73,$A3,$33,$8F,$25,$67,$BD,$16,$B6,$B4,$4C,$0C,$B4,$51,
                $90,$6B,$1A,$6B,$09,$E0,$59,$0D,$A8,$18,$E1,$70,$61,$C1,$01,$81);
  Skok:boolean=false;
  Okok:boolean=false;
  Dkok:boolean=false;
  Tok:Boolean=false;
  Tsok:boolean=false;
  Dateibz:menge=['A' .. 'Z', 'a' .. 'z', '0'..'9', '.', '_', ' ', ':'];
  Bu:menge=['A'..'Z', 'a'..'z'];
  ITA2_Hex:ITA_Reg=($18,$13,$0E,$12,$10,$16,$0B,$05,$0C,$1A,$1E,$09,$07,$06,
                    $03,$0D,$1D,$0A,$14,$01,$1C,$0F,$19,$17,$15,$11);
  ITA2_Bu:ITA_Zei=('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
                   'P','Q','R','S','T','U','V','W','X','Y','Z');
  ITA2_ZZ:ITA_Zei=('-','?',':','@','3','@','@','@','8','@','(',')','.',',','9','0',
                  '1','4','`','5','7','=','2','/','6','+');
  Steuerkomb_hex:array[1..6] of byte=($00,$02,$04,$08,$1B,$1F);
  Steuerkomb_zei:array[1..6] of char=('|', '<', ' ', '*', '#', '%');
  dech:char='D'; { Dechiffr.}
  chif:char='C'; { Chiffr.  }

{ ...................................................................SCHLSSEL }

procedure LiesSchl;
Type
  mtyp=set of char;
  bytefile=file of byte;

Var
  zeile:string;
  i,j:integer;

Const
  KennSk:string[17]='STRUKTURSCHLSSEL';
  KennOk:string[14]='GRUNDSCHLSSEL';
  Kenndk:string[5]='HHHHH';
  chrsk:mtyp=['0','1'];
  chrok:mtyp=['A'..'Z', 'a'..'z'];

function posit(vglstring:string;
               var datei:bytefile;
               dateiname:zeile60):longint;

Var
  n:integer;
  i:longint;
  ch:byte;

begin
  assign(datei,dateiname);
  {$I-} reset(datei); {$I+}
  if ioresult=0 then begin
                       i:=0;n:=1;
                       repeat
                         read(datei,ch);
                         inc(i);
                         if char(ch)=vglstring[n] then inc(n)
                                            else n:=1;
                       until ((eof(datei)) or (n=length(vglstring)+1));
                       if eof(datei) then posit:=0
                                     else posit:=i+1;
                     end
  else begin
         openwindowheader(30,10,60,20,' ERROR ');
         clrscr;
         write(' Dateifehler ! ');
         taste:=readkey;
         closewindow;    
         posit:=0;
       end;
  close(datei);
end;

procedure LiesabPos(Var Feld:string;pos:longint;menge:mtyp;
                    Var datei:bytefile;lg:integer);

Var
  i:longint;
  ch:byte;

begin
  reset(datei);
  seek(datei,pos);
  feld:='';
  for i:=1 to lg do begin
                      repeat
                        read(datei,ch);
                      until ((char(ch) in menge) or (i=lg));
                      feld:=feld+char(ch);
                    end;
  poszei:=filepos(datei);
  close(datei);
end;

procedure Sl_lesen(Var feld:string; name:zeile60; kennung:string128;
                   menge:mtyp; sl_laenge:integer);

Var
  datei:bytefile;
  p:longint;
  i:integer;
begin
  p:=posit(kennung,datei,name);
  if p=0 then Fillchar(feld,sizeof(feld),#32)
  else LiesabPos(feld,p,menge,datei,sl_laenge);
end;

begin
  skok:=true;dkok:=true;okok:=true;
  zeile:='';
  Sl_lesen(zeile,ifo_satz.datei_sl,kennsk,chrsk,128);
  for i:=0 to 7 do
    for j:=0 to 15 do SK[i,j]:=ord(zeile[i*16+j+1]);
  if sk[0,0]=32 then skok:=FALSE;
  zeile:='';
  Sl_lesen(zeile,ifo_satz.datei_sl,kennok,chrok,10);
  Ok:=copy(zeile,1,10);
  if ok[1]=#32 then okok:=false;
  zeile:='';
  case art of
     'C':Sl_lesen(zeile,ifo_satz.datei_kt,kenndk,chrok,30);
     'D':Sl_lesen(zeile,ifo_satz.datei_gt,kenndk,chrok,30);
  end;
  dk:='';
  for i:=1 to 10 do if zeile[3*(i-1)+1]=zeile[3*(i-1)+2] then
                      if zeile[3*(i-1)+2]=zeile[3*(i-1)+3] then
                        dk:=dk+zeile[3*(i-1)+1]
                        else dkok:=false
                        else dkok:=false;
  if ((skok and okok) and dkok) then Einok:=true
                                else Einok:=false;
end;

{............................................................F(X)= 2 HOCH X }


Function Pot2(x:integer):integer;
Var
  i:integer;
  Erg:integer;

begin
  if x=0 then pot2:=1
  else
    begin
      Erg:=1;
{      for i:=1 to x do Erg:=Erg*2;}
      Erg := Erg shl x;
      Pot2:=Erg;
    end;
end;

{..............................................................  REGISTERSATZ }

procedure RegVerSatz;

Var
  i:integer;
  rk:byte;

begin
  i:=31;
  rk:=regist[i] and maske[i];
  repeat
    dec(i);
    rk:=rk xor (regist[i] and maske[i]);
    regist[i+1]:=regist[i];
  until i=1;
  regist[i]:=rk;
  for i:=1 to 8 do c[i]:=$00 or ((rk and pot2(8-i)) shr (8-i));
end;

{............................................................  BU IN VEK(1..8) }

procedure Mzeile(Var Zeile:vektor;Bu:char);

Var
  i:integer;
  By:real;
  hiz:vektor;

begin
   bu:=upcase(bu);
   by:=ita2_hex[ord(bu)-64];
   for i:=8 downto 1 do
   begin
     if (by/Pot2(i-1)<1) then zeile[9-i]:=0
     else begin
            zeile[9-i]:=1;
            by:=by-Pot2(i-1);
          end;
     end;
   for i:=1 to 5 do
     hiz[i]:=zeile[i+3];
   for i:=6 to 8 do
     hiz[i]:=0;
   for i:=1 to 8 do
     zeile[i]:=(zeile[i] xor hiz[i]) and 1;
end;

{............................................................MATRIX B }

procedure MatrixB (Var mat:slmat; Grsl:string10);

Var
  i,j:integer;
  bu:char;
  zeile:vektor;

begin
  for i:=1 to 10 do
    begin
      bu:=grsl[i];
      mzeile(zeile,bu);
      for j:=1 to 8 do mat[i,j]:=zeile[j];
    end;
    for i:=2 to 7 do
      begin
      bu:=grsl[i];
      mzeile(zeile,bu);
      for j:= 1 to 8 do mat[9+i,j]:=zeile[j];
    end;
end;

{.............................................................MATRIX D }

procedure MatrixD (Var mat:slmat;Spsl:string10);

Var
  i,j:integer;
  bu: char;
  zeile:vektor;

begin
  for i:=1 to 10 do
    begin
      bu:=spsl[i];
      mzeile(zeile,bu);
      for j:=1 to 8 do mat[i,j]:=zeile[j];
    end;
    for i:=11 to 16 do
    begin
      bu:=spsl[i-10];
      mzeile(zeile,bu);
      for j:=1 to 8 do mat[i,j]:=zeile[j];
  end;
end;

{                                                          MATRIZEN B,D }

procedure GenMatx (var MTXB, MTXD:slmat; OK:string10; DK:string10);

begin
  matrixb(mtxb,ok);
  matrixd(mtxd,dk);
end;

{...........................................................INITIALFLLUNG }

procedure initregsatz (var re:regtyp; mb, md:slmat);

var
  i,j:integer;

begin
  re[1]:=$ff;
  for i:=1 to 10 do begin
                      re[i+1]:=$00;
                      for j:=1 to 8 do re[i+1]:=(re[i+1] shl 1) or (mb[i,9-j]
                                                  xor md[i,9-j]);
                    end;
  for i:=11 to 16 do begin
                       re[i+1]:=$00;
                       for j:=1 to 8 do re[i+1]:=(re[i+1] shl 1) or (mb[i,9-j]
                                                   xor md[i-10,9-j]);
                     end;
  for i:=17 to 20 do begin
                       re[i+1]:=$00;
                       for j:=1 to 8 do re[i+1]:=(re[i+1] shl 1) or (mb[i-16,9-j]
                                                    xor md[i-10,9-j]);
                     end;
  for i:=21 to 26 do begin
                       re[i+1]:=$00;
                       for j:=1 to 8 do re[i+1]:=(re[i+1] shl 1) or (mb[i-16,9-j]
                                                   xor md[i-20,9-j]);
                     end;
  for i:=27 to 30 do begin
                       re[i+1]:=$00;
                       for j:=1 to 8 do re[i+1]:=(re[i+1] shl 1) or (mb[i-25,9-j]
                                                   xor md[i-20,9-j]);
                     end;
end;

{.....................................................................MATRIX P }

procedure GenMtxP (Var SPMat:matrix; SKMat:matrix; OKMat,DkMat:slmat);

Var
  i,j,Anz1:integer;
  Ptest:boolean;

begin
  repeat
    Anz1:=0;
    for i:=0 to 7 do
      for j:=0 to 15 do
        begin
          SPMat[i,j]:=((ord(SkMat[i,j])-48) xor DKMat[j+1,8-i] xor OKMat[j+1,8-i]) and 1;
          Anz1:=Anz1 + SPMat[i,j];
        end;
        if ((Anz1<33) or (Anz1>95)) then ptest:=false
                                    else ptest:=true;  {keine nderung notwendig}
        if ptest=false then for i:=0 to 7 do
                              for j:=0 to 14 do Skmat[i,j]:=Skmat[i,j+1];
  until ptest=true;
  if ((Anz1/2)=int(anz1/2)) then spmat[0,0]:=spmat[0,0] xor 1;
end;

{.........................................................................ELEMENT P(I,J) }

procedure ElmPij (Var el:byte; mtxp:matrix; vek:vektor);

var
  i,zeile,spalte:integer;

begin
  zeile:=0; spalte:=0;
  for i:=1 to 4 do spalte:=spalte+vek[i]*Pot2(i-1);
  for i:=5 to 7 do zeile:=zeile+vek[i]*Pot2(i-5);
  el:=mtxp[zeile,spalte];
end;

{............................................................................GAMMA }

procedure Gamma (Var Gamma:byte; mtxp:matrix; vek:vektor; zt:byte);

Var Pij:byte;

begin
  ElmPij(Pij,mtxp,vek);
  Gamma:=Pij xor vek[8];
  Gamma:=Gamma xor zt;
end;


{........................................................................ELEMENT ZT }

procedure Elmzt (Var zt:byte; vek:vektor);

Var i:integer;

begin
  zt:=0;
  for i:=1 to 8 do zt:=zt xor vek[i];
end;

{..................................................................BYTE IN VEK(1..8) }

procedure Konv(var Feld:vektor; b:byte);

Var
  i,y:integer;

begin
  for i:=1 to 8 do
    begin
      y:=Pot2(8-i);
      if ((b-y)>=0) then begin
                            b:=b-y;
                            Feld[i]:=1;
                         end
      else Feld[i]:=0;
    end;
end;

{........................................................................IMPULS }

procedure Impuls(Var kombi:byte; Var flag:boolean);

Var i:integer;

begin
  for i:=1 to 26 do
    if ((kombi=byte(ITA2_Bu[i])) or (kombi=byte(ITA2_ZZ[i])))
       then kombi:=ITA2_hex[i];
  for i:=1 to 6 do
    if kombi=byte(steuerkomb_zei[i]) then kombi:=steuerkomb_hex[i];
end;

{..............................................................ADDITIONSEINHEIT }

procedure Addeinheit(Var AR:byte);

Var i:integer;

begin
  addel:=0;
  for i:=1 to bitvar do
    begin
      regversatz;
      gamma(gam,mtxp,c,zt);
      addel:=addel shl 1;
      addel:=addel xor gam;
      elmzt(zt,c);
    end;
  ar:=addel and 31;
end;

{..............................................................GRUPPENEINTEILUNG }

procedure gruppeneinteilung(Var Anz:integer);

const
  wr:byte=13;
  zv:byte=10;
  zw:byte=32;

begin
  inc(m);
  if m=5 then begin
                inc(anz);
                if anz=10 then begin
                                 write(char(wr),char(zv));
                                 write(zieldatei,wr,zv);
                                 anz:=0;
                               end
                          else begin
                                 write(char(zw));
                                 write(zieldatei,zw);
                               end;
                 m:=0;
               end;
end;

{..................................................................ZEICHEN }

procedure zeichen(Var z:byte; Var flag:boolean);

Var i:integer;

begin
  for i:=1 to 26 do if z=ITA2_hex[i] then if flag then z:=ord(ITA2_bu[i])
                                                  else z:=ord(ITA2_ZZ[i]);
  for i:=1 to 6 do if z=steuerkomb_hex[i] then z:=ord(steuerkomb_zei[i]);
  if z=ord('%') then flag:=true;
  if z=ord('#') then flag:=false;
end;

{..................................................................KLARTEXT }

procedure Klartext;

Var
  ch,chn:char;

Const
  wr:byte=13;
  zv:byte=10;

begin {1}
  if filepos(quelldatei)<=poszei then
    begin {2}
      repeat
        read(quelldatei,ghel);
      until ((char(ghel) in bu) or ((filepos(quelldatei)>poszei)
                                   or eof(quelldatei)));
  if char(ghel) in bu then
    begin {3}
      ch:=char(ghel);
      ch:=upcase(ch);
      ghel:=ord(ch);
      if ghel=ord('Y') then
        begin {4}
         if ((filepos(quelldatei)<=poszei) or not eof(quelldatei)) then
           repeat
             read(quelldatei,ghelnf);
           until ((char(ghelnf) in bu) or ((filepos(quelldatei)>poszei)
                                          or eof(quelldatei)))
         else textende:=true;
         if not textende then
           begin {5}
             chn:=char(ghelnf);
             chn:=upcase(chn);
             ghelnf:=ord(chn);
             case ghelnf of
               83:ghel:=ord('Y');
               75:ghel:=ord('%');
               74:ghel:=ord('#');
               72:ghel:=ord(' ');
               79:ghel:=ord('<');
               76:ghel:=ord('*');
               84:ghel:=ord('|');
             end;
             leertakte:=true;
           end; {5}
        end {4}
          else leertakte:=false;
     impuls(ghel,buflag);                                    { Fr 1:1 Dechiff. sind folgende // -> kommentar zu setzen }
     addeinheit(addel);
     klareinheit:=ghel xor addel;
     zeichen(klareinheit,buflag);
     case klareinheit of                                       { // hier aufzu }
{<}    60:klareinheit:=0;                                      { // hier aufzu }
{*}    42:begin write(chr(wr),chr(zv));                        { // hier auf }
            write(zieldatei,wr,zv);
          end;
     else begin
            case klareinheit of
              35,37:klareinheit:=0;
            end;
            if klareinheit<>0 then begin                       { // hier zu }
                                     write(char(klareinheit));
                                     write(zieldatei,klareinheit);
                                   end;                        { // hier auf }
            end;
      end; {case}                                               { // hier zu }
    end {3}
    else textende:=true;
    if leertakte then addeinheit(addel);
    end {2}
    else
      textende:=true;
end; {1}

{.......................................................................GEHEIMTEXT }

procedure geheimtext;

Var ch:char;

begin
  read(quelldatei,klareinheit);
  ch:=char(klareinheit);
  ch:=upcase(ch);
  klareinheit:=ord(ch);
  impuls(klareinheit,buflag);
  Addeinheit(addel);
  ghel:=klareinheit xor addel;
  case ghel of
    21:ghelnf:=20; { YS - Y  }
    02:ghelnf:=03; { YO - WR }
    08:ghelnf:=09; { YL - ZV }
    31:ghelnf:=30; { YK - BU }
    27:ghelnf:=26; { YJ - ZZ }
    04:ghelnf:=05; { YH - ZW }
    00:ghelnf:=01; { YT - 32 }
  end;
  case ghel of
    21,02,08,31,27,04,00:begin ghel:=21;
                                leertakte:=true;
                          end
    else leertakte:=false;
    end;
  buflag:=true;
  zeichen(ghel,buflag);
  write(char(ghel));
  write(zieldatei,ghel);
  gruppeneinteilung(gr);
  if leertakte then
    begin
      zeichen(ghelnf,buflag);
      write(char(ghelnf));
      write(zieldatei,ghelnf);
      gruppeneinteilung(gr);
      addeinheit(addel);
    end;
end;

{....................................................................KOPIEREN  }

procedure Kopybis(pos:longint);

Var el:byte;
    i:longint;
    ch:char;

begin
  seek(quelldatei,0);
  seek(zieldatei,0);
  for i:=0 to pos do
    begin
      read(quelldatei,el);
      ch:=char(el);
      ch:=upcase(ch);
      el:=byte(ch);
      write(zieldatei,el);
      write(char(el));
    end;
end;

procedure Kopyab(pos:longint);

Var el:byte;
    code:integer;

begin
  seek(quelldatei,pos);
  {$I-}code:=ioresult;{$I+}
  if code <> 0 then
    repeat
      read(quelldatei,el);
      write(zieldatei,el);
      write(char(el));
    until eof(quelldatei);
end;

{..........................................................VORLAUF }

procedure vorlauf;

Var t:integer;

begin
  t:=0;
  zt:=0;
  repeat
    inc(t);
    regversatz;
    elmzt(zt,c);
  until t=150;
end;

{.......................................................DATEIEN CLOSE }

procedure Closeqzsdat;

begin
  close(quelldatei);
  close(zieldatei);
  close(sldatei);
end;

{........................................................GEHEIMTEXTENDE }

procedure Endgt(Var Pos:longint);

Var
  lgr:longint;
  i:integer;
  ng:boolean;
  by:byte;

Const
  yps:byte=89;
  bu:set of byte=[65..90];

begin
  lgr:=0;i:=5;ng:=true;
  repeat
    read(quelldatei,by);
    inc(pos);
    if ((by in bu) and (i<=5)) then
      begin
        if ng then begin i:=0;
                         ng:=false;
                   end;
        inc(i);
        if i=5 then begin
                      lgr:=pos;
                      ng:=true;
                    end;
    end;
  until ((eof(quelldatei)) or ((i>5) or ((i<>5) and not(by in bu))));
  if i=5 then
          begin
           if lgr>0 then begin
                           repeat
                             seek(quelldatei,lgr);
                             read(quelldatei,by);
                             dec(lgr);
                           until by<>yps;
                           inc(lgr);
                         end;
           end;
  pos:=lgr;
end;

{........................................................................DECHIFFRIERUNG }

procedure Dechiff;

Var
  p:longint;

begin
  with ifo_satz do
    begin
      assign(quelldatei,datei_gt);
      assign(zieldatei,datei_kt);
      assign(sldatei,datei_sl);
      {$I-} reset(quelldatei);
            codeq:=ioresult;
            rewrite(zieldatei);
            codez:=ioresult;
            reset(sldatei);
            codes:=ioresult; {$I+}
    end;
    if (codeq+codez+codes)=0 then
                               begin
                                 LiesSchl;
                                 kopybis(poszei);
                                 poskenn:=poszei;
                                 endgt(poszei);
                                 seek(quelldatei,poskenn);
                                 Genmatx(mtxb,mtxd,ok,dk);
                                 initregsatz(regist,mtxb,mtxd);
                                 genmtxp(mtxp,sk,mtxb,mtxd);
                                 vorlauf;
                                 textende:=false;buflag:=true;
                                 wrzv:=false;
                                 while not textende do
                                   Klartext;
                                 Kopyab(poszei);
                               end
                             else
                               begin
                                 openwindow(3,3,33,13);
                                 write('Dateifehler in ');
                                 if codeq>0 then writeln('Quelldatei');
                                 if codez>0 then writeln('Zieldatei');
                                 if codes>0 then writeln('Schlsseldatei');
                                 write('...weiter mit Taste');
                                 taste:=readkey;
                                 closewindow;   
                               end;
  closeqzsdat;
end;

{......................................................................CHIFFRIEREN }

procedure Chiff;

Var
  i:integer;

Const
  yps:byte=89;

begin
  with ifo_satz do
  begin
    assign(quelldatei,datei_kt);
    assign(zieldatei,datei_gt);
    assign(sldatei,datei_sl);
    {$I-} reset(quelldatei);
          codeq:=ioresult;
          rewrite(zieldatei);
          codez:=ioresult;
          reset(sldatei);
          codes:=ioresult; {$I+}
  end;
  if (codeq+codez+codes)=0 then
                             begin
                               LiesSchl;
                               Kopybis(poszei);
                               Genmatx(mtxb,mtxd,ok,dk);
                               initregsatz(regist,mtxb,mtxd);
                               genmtxp(mtxp,sk,mtxb,mtxd);
                               vorlauf;
                               m:=0;gr:=6;
                               repeat
                                 geheimtext;
                               until eof(quelldatei);
                               if m>0 then
                                 for i:=m to 4 do
                                   begin
                                     write(char(yps));
                                     write(zieldatei,yps);
                                   end;
                             end
                           else
                             begin
                               openwindow(3,3,33,13);
                               write('Dateifehler in ');
                               if codeq>0 then writeln('Quelldatei');
                               if codez>0 then writeln('Zieldatei');
                               if codes>0 then writeln('Schlsseldatei');
                               write('....weiter mit Taste');
                               taste:=readkey;
                               closewindow;
                            end;
  closeqzsdat;
end;

{*****************************************************************************
                                     HAUPTPROGRAMM
*****************************************************************************}

begin
  bitvar:=5;
  with Ifo_satz do
    begin
    case art of
      'C':chiff;
      'D':dechiff;
    end;
  end;
end;

{..............................................................RAHMENPRGGRAMM }

begin
  betrart:=paramstr(1);
  taste:=betrart[1];
  taste:=upcase(taste);
  with ifo_satz do begin
                     verf_bez:=paramstr(2);
                     datei_kt:=paramstr(5);
                     datei_gt:=paramstr(4);
                     datei_sl:=paramstr(3);
                   end;
  window(2,12,79,19);
  simvars(taste,Ifo_satz);
  window(1,1,80,25);
end.